
// (c) COPYRIGHT URI/MIT 1999
// Please read the full copyright statement in the file COPYRIGHT.
//
// Authors:
//      jhrg,jimg       James Gallagher (jgallagher@gso.uri.edu)

// Implementation for ClientInt16. See ClientByte.cc
//
// jhrg 1/12/95

// $Log: ClientInt16.cc,v $
// Revision 1.2.8.2  2000/08/25 23:38:06  jimg
// Added extern bool numeric_to_float global.
//
// Revision 1.2.8.1  2000/06/02 23:03:31  jimg
// Fixes for AttrTables with no entries.
// Added support for name translation and a DODS_ML_Real_Name attribute.
// Changed the `size' attribtue's name to DODS_ML_Size.
//
// Revision 1.2  1999/04/30 17:06:55  jimg
// Merged with no-gnu and release-2-24
//
// Revision 1.1  1999/03/29 21:22:54  jimg
// Added
//

#ifdef __GNUG__
#pragma implementation
#endif

#include <assert.h>
#include <iostream.h>
#include <string>

#include <Pix.h>
#include <SLList.h>

#include "ClientInt16.h"
#include "name_map.h"

extern name_map names;
extern bool translate;
extern bool numeric_to_float;
extern bool ascii;

Int16 *
NewInt16(const string &n)
{
    return new ClientInt16(n);
}

ClientInt16::ClientInt16(const string &n) : Int16(n)
{
}

BaseType *
ClientInt16::ptr_duplicate()
{
    return new ClientInt16(*this);
}

bool
ClientInt16::read(const string &, int &)
{
    assert(false);
    return false;
}

void 
ClientInt16::print_val(ostream &os, string, bool print_decl_p)
{
    if (print_decl_p)
	os << type_name() << endl << names.lookup(name(), translate) << endl;

    if (numeric_to_float) {
	dods_float64 df = _buf;
	if (ascii)
	    os << df << " ";
	else
	    os.write((void *)&df, sizeof(dods_float64));
    }
    else {
	if (ascii)
	    os << _buf << " ";
	else
	    os.write((void *)&_buf, sizeof(dods_int16));
    }	
}

AttrTable &
ClientInt16::getAttrTable()
{
    return _attr;
}

void 
ClientInt16::setAttrTable(AttrTable &attr)
{
    _attr = attr;
}
