
// (c) COPYRIGHT URI/MIT 1999
// Please read the full copyright statement in the file COPYRIGHT.
//
// Authors:
//      jhrg,jimg       James Gallagher (jgallagher@gso.uri.edu)

// Implementation for ClientInt16. See ClientByte.cc
//
// jhrg 11/1/96

// $Log: ClientUInt16.cc,v $
// Revision 1.2.8.2  2000/08/25 23:37:36  jimg
// Added extern bool numeric_to_float global.
//
// Revision 1.2.8.1  2000/06/02 23:03:32  jimg
// Fixes for AttrTables with no entries.
// Added support for name translation and a DODS_ML_Real_Name attribute.
// Changed the `size' attribtue's name to DODS_ML_Size.
//
// Revision 1.2  1999/04/30 17:06:55  jimg
// Merged with no-gnu and release-2-24
//
// Revision 1.1  1999/03/29 21:22:54  jimg
// Added
//

#ifdef __GNUG__
#pragma implementation
#endif

#include <assert.h>
#include <iostream.h>

#include <string>

#include "ClientUInt16.h"
#include "name_map.h"

extern name_map names;
extern bool ascii;
extern bool translate;
extern bool numeric_to_float;

UInt16 *
NewUInt16(const string &n)
{
    return new ClientUInt16(n);
}

ClientUInt16::ClientUInt16(const string &n) : UInt16(n)
{
}

BaseType *
ClientUInt16::ptr_duplicate()
{
    return new ClientUInt16(*this);
}

bool
ClientUInt16::read(const string &, int &)
{
    assert(false);
    return false;
}

void 
ClientUInt16::print_val(ostream &os, string, bool print_decl_p)
{
    if (print_decl_p)
	os << type_name() << endl << names.lookup(name(), translate) << endl;

    if (numeric_to_float) {
	dods_float64 df = _buf;
	if (ascii)
	    os << df << " ";
	else
	    os.write((void *)&df, sizeof(dods_float64));
    }
    else {
	if (ascii)
	    os << _buf << " ";
	else
	    os.write((void *)&_buf, sizeof(dods_uint16));
    }	
}


AttrTable &
ClientUInt16::getAttrTable()
{
    return _attr;
}

void 
ClientUInt16::setAttrTable(AttrTable &attr)
{
    _attr = attr;
}
