
// -*- C++ -*-

// Unit tests for the name_map class. 8/24/2000 jhrg

#include "CppUnit/TestCase.h"
#include "CppUnit/TestCaller.h"
#include "CppUnit/TestResult.h"
#include "CppUnit/TestSuite.h"

#include "name_map.h"

class name_map_test : public TestCase
{
private:
  name_map *nm_empty;

public:
  void setUp ()
  {
    nm_empty = new name_map();
  }

  void tearDown ()
  {
    delete nm_empty;
  }

  void testCanonical() 
  {
    assert(nm_empty->lookup("id", true) == "id");
    assert(nm_empty->lookup("id_long", true) == "id_long");
    assert(nm_empty->lookup("id%20long", true) == "id_long");
    assert(nm_empty->lookup("id.long", true) == "id_long");
    assert(nm_empty->lookup("id$long", true) == "id_long");
    assert(nm_empty->lookup("id^long", true) == "id_long");
    assert(nm_empty->lookup("id%20long%20long", true) == "id_long_long");

    assert(nm_empty->lookup("id", false) == "id");
    assert(nm_empty->lookup("id_long", false) == "id_long");
    assert(nm_empty->lookup("id%20long", false) == "id%20long");
    assert(nm_empty->lookup("id.long", false) == "id.long");
    assert(nm_empty->lookup("id$long", false) == "id$long");
    assert(nm_empty->lookup("id^long", false) == "id^long");
    assert(nm_empty->lookup("id%20long%20long", false) == "id%20long%20long");
  }

public:
  name_map_test(string name): TestCase(name) {}

  static Test *suite()
  {
    TestSuite *suite = new TestSuite;
    suite->addTest(new TestCaller<name_map_test>("testCanonical", 
				  &name_map_test::testCanonical));
    return suite;
  }
};

